import {render} from "./deps.js";
import {store} from "./store.js";


export default class BaseElement extends HTMLElement {

    slice = {};
    unsubscribeCallback;

    connectedCallback() {
        this.unsubscribeCallback = store.subscribe(_ => this.onStateUpdate());
        this.slice = this.extractSlice(store.getState());
        render(this.view(), this.getRenderTarget());
    }

    disconnectedCallback() {
        this.unsubscribeCallback();
        this.slice = null;
    }


    extractSlice(reduxState) {
        return reduxState;
    }

    getRenderTarget() {
        return this;
    }

    onStateUpdate() {
        render(this.view(), this.getRenderTarget());
    }


    view() {
    }

}
